unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, IBConnection, SQLDB, SQLDBLib, DB, Forms, Controls,
  Graphics, Dialogs, Grids, ComCtrls, ExtCtrls, StdCtrls, DBGrids, DateUtils;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Edit1: TEdit;
    IBConnection1: TIBConnection;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    OpenDialog1: TOpenDialog;
    Panel1: TPanel;
    Panel2: TPanel;
    SaveDialog1: TSaveDialog;
    SQLDBLibraryLoader1: TSQLDBLibraryLoader;
    SQLQuery1: TSQLQuery;
    SQLTransaction1: TSQLTransaction;
    StatusBar1: TStatusBar;
    StringGrid1: TStringGrid;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    function  RandomString(size: integer): string;
    procedure FillStringGrid();
    procedure FillDBGrid();
  private

  public

  end;


var
  Form1: TForm1;
  N: integer = 50000;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FillStringGrid();
var
  i:           integer;
  FromTime,
  ToTime:      TDateTime;
  DiffSeconds: integer;

begin
  Screen.Cursor := crHourGlass;

  Randomize; { This way we generate a new sequence every time the program is run}

  StringGrid1.BeginUpdate;
  StringGrid1.RowCount := N + StringGrid1.FixedRows;

  FromTime := Now;
  Label3.caption := 'Fülle Zufallsdaten in das StringGrid...';
  Label3.Font.color := clGreen;
  Label3.visible := true;
  Form1.Refresh;

  try
    for i:=StringGrid1.FixedRows to StringGrid1.RowCount-1 do
    begin
      //for primary key
      StringGrid1.Cells[1, i] := IntToStr(i);
      //System
      StringGrid1.Cells[2, i] := RandomString(10);    //240
      //Measuremet kategory
      StringGrid1.Cells[3, i] := RandomString(10);    //240
      //Measuremet format numerical, alphanumerical
      StringGrid1.Cells[4, i] := RandomString(5);
      //Mesurement code
      StringGrid1.Cells[5, i] := RandomString(10);    //1000
      //Mesurement code description
      StringGrid1.Cells[6, i] := RandomString(100);   //1000
      //Mesurement value
      StringGrid1.Cells[7, i] := RandomString(20);    //8000
      //Mesurement unit h, v, A, s etc.
      StringGrid1.Cells[8, i] := RandomString(3);     //240
    end;
  finally
    StringGrid1.AutoSizeColumns;
    StringGrid1.EndUpdate;
  end;

  ToTime := Now;

  DiffSeconds := SecondsBetween(ToTime,FromTime);

  Label3.visible := false;
  Label3.caption := IntToStr(i) + ' Zeilen in ' + IntToStr(DiffSeconds) + ' Sekunden in das StringGrid geschrieben.';
  Label3.Font.color := clGreen;
  Label3.visible := true;
  Form1.Refresh;

  Screen.Cursor := crDefault;

end;

procedure TForm1.FillDBGrid();
var
  i:           integer;
  FromTime,
  ToTime:      TDateTime;
  DiffSeconds: integer;

begin
  //SQLQuery1.DisableControls;
  DBGrid1.Clear;

  Screen.Cursor := crHourGlass;
  Label2.caption := 'Daten/Zeilen werden in die Datenbank geschrieben...';
  Label2.Font.color := clGreen;
  Label2.visible := true;
  Form1.Refresh;

  FromTime := Now;

  //insert
  try
    for i:= StringGrid1.FixedRows to StringGrid1.RowCount-1 do
    begin
      SQLQuery1.SQL.Text := 'INSERT INTO messwerte (id, system, kategorie, format, code, langtext, wert, einheit) VALUES(:id, :system, :kategorie, :format, :code, :langtext, :wert, :einheit)';
      SQLQuery1.ParamByName('id').AsLargeint           := StrToInt64(StringGrid1.Cells[1, i]);
      SQLQuery1.ParamByName('system').AsString         := StringGrid1.Cells[2, i];
      SQLQuery1.ParamByName('kategorie').AsString      := StringGrid1.Cells[3, i];
      SQLQuery1.ParamByName('format').AsString         := StringGrid1.Cells[4, i];
      SQLQuery1.ParamByName('code').AsString           := StringGrid1.Cells[5, i];
      SQLQuery1.ParamByName('langtext').AsString       := StringGrid1.Cells[6, i];
      SQLQuery1.ParamByName('wert').AsString           := StringGrid1.Cells[7, i];
      SQLQuery1.ParamByName('einheit').AsString        := StringGrid1.Cells[8, i];
      SQLQuery1.ExecSQL;
    end
  except
    on E : Exception do
    begin
      SQLTransaction1.Rollback;
      exit
    end;
  end;
  SQLTransaction1.Commit;
  ToTime := Now;

  DiffSeconds := SecondsBetween(ToTime,FromTime);

  Label2.visible := false;
  Label2.caption := IntToStr(i) + ' Zeilen in ' + IntToStr(DiffSeconds) + ' Sekunden in die Datenbank geschrieben. Fülle nun das DBGrid mit Daten...';
  Label2.Font.color := clGreen;
  Label2.visible := true;
  Form1.Refresh;

  FromTime := Now;

  //read table data into DBGrid
  try
    SQLQuery1.Close;
    SQLQuery1.SQL.Clear;
    SQLQuery1.SQL.Text:= 'SELECT * FROM messwerte';
    IBConnection1.Connected:= True;
    SQLTransaction1.Active:= True;
    //SQLQuery1.DisableControls;
    //DBGrid1.DataSource := nil;
    SQLQuery1.PacketRecords := -1;
    //DBGrid1.Options.dgThumbTracking := true;
    DBGrid1.BeginUpdate;
    SQLQuery1.Open;
    SQLQuery1.Last;
    SQLQuery1.First;
    DBGrid1.EndUpdate;
    //DBGrid1.DataSource := DataSource1;
    //SQLQuery1.EnableControls;
  except
    on E : Exception do
    begin
      ShowMessage('Fehler beim Einlesen der Daten in das DBGrid!');
      exit
    end;
  end;
  ToTime := Now;

  DiffSeconds := SecondsBetween(ToTime,FromTime);

  Label2.visible := false;
  Label2.caption := 'DBGrid gefüllt mit ' + IntToStr(i) + ' Zeilen. Benötigte Zeit dafür: ' + IntToStr(DiffSeconds) + ' Sekunden.';
  Label2.Font.color := clGreen;
  Label2.visible := true;

  Screen.Cursor := crDefault;
  //SQLQuery1.EnableControls;
  DBGrid1.AutoAdjustColumns;
end;


function TForm1.RandomString(size: integer): string;
var
  i: integer;
  s: string;

begin
  s := '';
  SetLength(s, Random(size)+1);
  for i := 1 to Length(s) do
    s[i] := char(ord('A') + random(26));
  RandomString := s;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Edit1.text := IntToStr(N);
  Label2.Caption := '';
  Label3.Caption := '';
  FillStringGrid;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Label2.caption := '';
  Label2.visible := false;
  Form1.Refresh;

  StringGrid1.Clean;

  Screen.Cursor := crHourGlass;
  try
    N := Abs(StrToInt(Edit1.text));
  except
    on E : Exception do
    begin
      ShowMessage('Bitte ganzzahlige und positive Zahl eingeben!');
      N := 1000;
      Edit1.text := IntToStr(N);
    end;
    else writeln('This is not an Exception-descendant at all!');
  end;
  FillStringGrid;
  Screen.Cursor := crDefault;
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  FromTime,
  ToTime:      TDateTime;
  DiffSeconds: integer;

begin
  Screen.Cursor := crHourGlass;

  Label3.caption := 'Speichere StrinGrid Daten in eine CSV...';
  Label3.Font.color := clGreen;
  Label3.visible := true;
  Form1.Refresh;

  StringGrid1.BeginUpdate;

  if SaveDialog1.Execute then
  begin
    FromTime := Now;
    StringGrid1.SaveToCSVFile(SaveDialog1.Filename);
  end;

  StringGrid1.EndUpdate;

  ToTime := Now;

  DiffSeconds := SecondsBetween(ToTime,FromTime);

  Label3.visible := false;
  Label3.caption := IntToStr(StringGrid1.RowCount-StringGrid1.FixedRows) + ' Zeilen in ' + IntToStr(DiffSeconds) + ' Sekunden als CSV Datei geschrieben.';
  Label3.Font.color := clGreen;
  Label3.visible := true;
  Form1.Refresh;

  Screen.Cursor := crDefault;
end;

procedure TForm1.Button4Click(Sender: TObject);
var
  FromTime,
  ToTime:      TDateTime;
  DiffSeconds: integer;

begin
  Screen.Cursor := crHourGlass;

  Label3.caption := 'Lade Daten aus einer CSV Datei in das StringGrid...';
  Label3.Font.color := clGreen;
  Label3.visible := true;
  Form1.Refresh;

  StringGrid1.BeginUpdate;

  if OpenDialog1.Execute then
  begin
    FromTime := Now;
    StringGrid1.LoadFromCSVFile(OpenDialog1.FileName);
  end;
  StringGrid1.EndUpdate;

  ToTime := Now;
  DiffSeconds := SecondsBetween(ToTime,FromTime);

  Edit1.text := IntToStr(StringGrid1.RowCount-StringGrid1.FixedRows);

  Label3.visible := false;
  Label3.caption := IntToStr(StringGrid1.RowCount-StringGrid1.FixedRows) + ' Zeilen aus einer CSV Datei in ' + IntToStr(DiffSeconds) + ' Sekunden in das StringGrid geschrieben.';
  Label3.Font.color := clGreen;
  Label3.visible := true;
  Form1.Refresh;

  Screen.Cursor := crDefault;

end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  SQLTransaction1.Active:= False;
  IBConnection1.Connected:= False;

  // Achtung Datei "TestDB.FDB" im aktuellen Verzeichnis wird gnadenlos gelöscht!!!!
  DeleteFile('TestDB.FDB');

  IBConnection1.DatabaseName := 'TestDB.FDB';
  IBConnection1.UserName     := 'SYSDBA';
  IBConnection1.Password     := 'masterkey';
  IBConnection1.Charset := 'UTF8'; //Send and receive string data in UTF8 encoding
  IBConnection1.Dialect := 3; //Nobody uses 1 or 2 anymore.
  IBConnection1.Params.Add('PAGE_SIZE=8192');
  //IBConnection1.Params.Add('PAGE_SIZE=16384');
  IBConnection1.CreateDB;

  IBConnection1.Transaction := SQLTransaction1;
  IBConnection1.Open;

  SQLTransaction1.StartTransaction;
  //IBConnection1.ExecuteDirect('CREATE TABLE messwerte (id BIGINT, system VARCHAR(10), kategorie VARCHAR(10), format VARCHAR(5), code VARCHAR(20), langtext VARCHAR(100), wert VARCHAR(100), einheit VARCHAR(20))');
  IBConnection1.ExecuteDirect('CREATE TABLE messwerte (id BIGINT, system VARCHAR(240), kategorie VARCHAR(240), format VARCHAR(5), code VARCHAR(1000), langtext VARCHAR(1000), wert VARCHAR(8000), einheit VARCHAR(240))');
  IBConnection1.ExecuteDirect('CREATE UNIQUE INDEX messwerte_idx1 ON messwerte(id)');
  //IBConnection1.ExecuteDirect('CREATE INDEX messwerte_idx1 ON messwerte(diagnosesystem)');
  //IBConnection1.ExecuteDirect('CREATE INDEX messwerte_idx2 ON messwerte(kategorie)');
  //IBConnection1.ExecuteDirect('CREATE INDEX messwerte_idx3 ON messwerte(bezeichnung)');
  //gstat C:\Arne\DevWork\Pascal\data\FAP\FAP.FDB -u SYSDBA -p masterkey -r
  SQLTransaction1.Commit;

  FillDBGrid();
end;

end.

